aboutsummaryrefslogtreecommitdiff
path: root/handlers/mysql.in
diff options
context:
space:
mode:
Diffstat (limited to 'handlers/mysql.in')
-rw-r--r--handlers/mysql.in364
1 files changed, 183 insertions, 181 deletions
diff --git a/handlers/mysql.in b/handlers/mysql.in
index b304833..3488c51 100644
--- a/handlers/mysql.in
+++ b/handlers/mysql.in
@@ -1,4 +1,5 @@
# -*- mode: sh; sh-basic-offset: 3; indent-tabs-mode: nil; -*-
+# vim: set filetype=sh sw=3 sts=3 expandtab autoindent:
#
# mysql handler script for backupninja
#
@@ -10,6 +11,7 @@ getconf nodata
getconf dbhost localhost
getconf hotcopy no
getconf sqldump no
+getconf sqldumpoptions "--lock-tables --complete-insert --add-drop-table --quick --quote-names"
getconf compress yes
getconf vsname
@@ -46,9 +48,9 @@ fi
ignore=''
for i in $ignores $nodata; do
- ignore="$ignore --ignore-table=$i"
+ ignore="$ignore --ignore-table=$i"
done
-
+
# create backup dirs, $vroot will be empty if no vsname was specified
# and we will instead proceed to operate on the host
[ -d $vroot$backupdir ] || mkdir -p $vroot$backupdir
@@ -58,11 +60,11 @@ dumpdir="$backupdir/sqldump"
if [ $usevserver = yes ]
then
- [ "$sqldump" == "no" -o -d $vroot$dumpdir ] || $VSERVER $vsname exec mkdir -p $dumpdir
- [ "$hotcopy" == "no" -o -d $vroot$hotdir ] || $VSERVER $vsname exec mkdir -p $hotdir
+ [ "$sqldump" == "no" -o -d $vroot$dumpdir ] || $VSERVER $vsname exec mkdir -p $dumpdir
+ [ "$hotcopy" == "no" -o -d $vroot$hotdir ] || $VSERVER $vsname exec mkdir -p $hotdir
else
- [ "$sqldump" == "no" -o -d $dumpdir ] || mkdir -p $dumpdir
- [ "$hotcopy" == "no" -o -d $hotdir ] || mkdir -p $hotdir
+ [ "$sqldump" == "no" -o -d $dumpdir ] || mkdir -p $dumpdir
+ [ "$hotcopy" == "no" -o -d $hotdir ] || mkdir -p $hotdir
fi
#######################################################################
@@ -86,35 +88,35 @@ defaultsfile=""
if [ "$dbusername" != "" -a "$dbpassword" != "" ]
then
- if [ $usevserver = yes ]
- then
- home=`$VSERVER $vsname exec getent passwd "root" | @AWK@ -F: '{print $6}'`
- else
- home=`getent passwd "root" | @AWK@ -F: '{print $6}'`
- fi
+ if [ $usevserver = yes ]
+ then
+ home=`$VSERVER $vsname exec getent passwd "root" | @AWK@ -F: '{print $6}'`
+ else
+ home=`getent passwd "root" | @AWK@ -F: '{print $6}'`
+ fi
- [ -d $home ] || fatal "Can't find root's home directory ($home)."
+ [ -d $home ] || fatal "Can't find root's home directory ($home)."
- mycnf="$home/.my.cnf"
+ mycnf="$home/.my.cnf"
- if [ $usevserver = yes ]
- then
+ if [ $usevserver = yes ]
+ then
workcnf="$vroot$mycnf"
- else
+ else
workcnf="$mycnf"
- fi
+ fi
- if [ -f $workcnf ]
- then
+ if [ -f $workcnf ]
+ then
# rename temporarily
tmpcnf="$workcnf.disable"
debug "mv $workcnf $tmpcnf"
mv $workcnf $tmpcnf
- fi
+ fi
- oldmask=`umask`
- umask 077
- cat > $workcnf <<EOF
+ oldmask=`umask`
+ umask 077
+ cat > $workcnf <<EOF
# auto generated backupninja mysql conf
[mysql]
host=$dbhost
@@ -136,37 +138,37 @@ host=$dbhost
user=$dbusername
password="$dbpassword"
EOF
- umask $oldmask
- defaultsfile="--defaults-extra-file=$mycnf"
+ umask $oldmask
+ defaultsfile="--defaults-extra-file=$mycnf"
fi
# if a user is not set, use $configfile, otherwise use $mycnf
if [ "$user" == "" ]; then
- user=root;
- defaultsfile="--defaults-extra-file=$configfile"
+ user=root;
+ defaultsfile="--defaults-extra-file=$configfile"
else
- userset=true;
- if [ $usevserver = yes ]
- then
- userhome=`$VSERVER $vsname exec getent passwd "$user" | @AWK@ -F: '{print $6}'`
- if [ $? -eq 2 ]
- then
- fatal "User $user not found in /etc/passwd"
- fi
- debug "User home set to: $vroot$userhome"
- [ -f $vroot$userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
- else
- userhome=`getent passwd "$user" | @AWK@ -F: '{print $6}'`
- if [ $? -eq 2 ]
- then
- fatal "User $user not found in /etc/passwd"
- fi
- debug "User home set to: $userhome"
- [ -f $userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
- fi
+ userset=true;
+ if [ $usevserver = yes ]
+ then
+ userhome=`$VSERVER $vsname exec getent passwd "$user" | @AWK@ -F: '{print $6}'`
+ if [ $? -eq 2 ]
+ then
+ fatal "User $user not found in /etc/passwd"
+ fi
+ debug "User home set to: $vroot$userhome"
+ [ -f $vroot$userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
+ else
+ userhome=`getent passwd "$user" | @AWK@ -F: '{print $6}'`
+ if [ $? -eq 2 ]
+ then
+ fatal "User $user not found in /etc/passwd"
+ fi
+ debug "User home set to: $userhome"
+ [ -f $userhome/.my.cnf ] || fatal "Can't find config file in $userhome/.my.cnf"
+ fi
- defaultsfile="--defaults-extra-file=$userhome/.my.cnf"
- debug "using $defaultsfile"
+ defaultsfile="--defaults-extra-file=$userhome/.my.cnf"
+ debug "using $defaultsfile"
fi
#######################################################################
@@ -174,55 +176,55 @@ fi
if [ "$hotcopy" == "yes" ]
then
- info "Initializing hotcopy method"
- if [ "$databases" == "all" ]
- then
- if [ $usevserver = yes ]
- then
- info "dbhost: $dbhost"
- execstr="$VSERVER $vsname exec $MYSQLHOTCOPY -h $dbhost --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
- else
- execstr="$MYSQLHOTCOPY --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
- fi
- debug "su $user -c \"$execstr\""
- if [ ! $test ]
- then
- output=`su $user -c "$execstr" 2>&1`
- code=$?
- if [ "$code" == "0" ]
- then
- debug $output
- info "Successfully finished hotcopy of all mysql databases"
- else
- warning $output
- warning "Failed to hotcopy all mysql databases"
- fi
- fi
- else
- for db in $databases
- do
- if [ $usevserver = yes ]
- then
- execstr="$VSERVER $vsname exec $MYSQLHOTCOPY --allowold $db $hotdir"
- else
- execstr="$MYSQLHOTCOPY --allowold $db $hotdir"
- fi
- debug 'su $user -c \"$execstr\"'
- if [ ! $test ]
- then
- output=`su $user -c "$execstr" 2>&1`
- code=$?
- if [ "$code" == "0" ]
- then
- debug $output
- info "Successfully finished hotcopy of mysql database $db"
- else
- warning $output
- warning "Failed to hotcopy mysql database $db"
- fi
- fi
- done
- fi
+ info "Initializing hotcopy method"
+ if [ "$databases" == "all" ]
+ then
+ if [ $usevserver = yes ]
+ then
+ info "dbhost: $dbhost"
+ execstr="$VSERVER $vsname exec $MYSQLHOTCOPY -h $dbhost --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
+ else
+ execstr="$MYSQLHOTCOPY --quiet --allowold --regexp /.\*/./.\*/ $hotdir"
+ fi
+ debug "su $user -c \"$execstr\""
+ if [ ! $test ]
+ then
+ output=`su $user -c "$execstr" 2>&1`
+ code=$?
+ if [ "$code" == "0" ]
+ then
+ debug $output
+ info "Successfully finished hotcopy of all mysql databases"
+ else
+ warning $output
+ warning "Failed to hotcopy all mysql databases"
+ fi
+ fi
+ else
+ for db in $databases
+ do
+ if [ $usevserver = yes ]
+ then
+ execstr="$VSERVER $vsname exec $MYSQLHOTCOPY --allowold $db $hotdir"
+ else
+ execstr="$MYSQLHOTCOPY --allowold $db $hotdir"
+ fi
+ debug 'su $user -c \"$execstr\"'
+ if [ ! $test ]
+ then
+ output=`su $user -c "$execstr" 2>&1`
+ code=$?
+ if [ "$code" == "0" ]
+ then
+ debug $output
+ info "Successfully finished hotcopy of mysql database $db"
+ else
+ warning $output
+ warning "Failed to hotcopy mysql database $db"
+ fi
+ fi
+ done
+ fi
fi
##########################################################################
@@ -230,97 +232,97 @@ fi
if [ "$sqldump" == "yes" ]
then
- info "Initializing SQL dump method"
- if [ "$databases" == "all" ]
- then
- if [ $usevserver = yes ]
- then
- debug 'echo show databases | $VSERVER $vsname exec su $user -c \"$MYSQL $defaultsfile\" | grep -v Database'
- databases=`echo 'show databases' | $VSERVER $vsname exec su $user -c "$MYSQL $defaultsfile" | grep -v Database`
- if [ $? -ne 0 ]
- then
- fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
- fi
- else
- databases=$(su $user -c "$MYSQL $defaultsfile -N -B -e 'show databases'" | sed 's/|//g;/\+----/d')
- if [ $? -ne 0 ]
- then
- fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
- fi
- fi
- fi
+ info "Initializing SQL dump method"
+ if [ "$databases" == "all" ]
+ then
+ if [ $usevserver = yes ]
+ then
+ debug 'set -o pipefail ; echo show databases | $VSERVER $vsname exec su $user -c \"$MYSQL $defaultsfile\" | grep -v Database'
+ databases=`set -o pipefail ; echo 'show databases' | $VSERVER $vsname exec su $user -c "$MYSQL $defaultsfile" | grep -v Database`
+ if [ $? -ne 0 ]
+ then
+ fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
+ fi
+ else
+ databases=$(set -o pipefail ; su $user -c "$MYSQL $defaultsfile -N -B -e 'show databases'" | sed 's/|//g;/\+----/d')
+ if [ $? -ne 0 ]
+ then
+ fatal "Authentication problem, maybe user/password is wrong or mysqld is not running?"
+ fi
+ fi
+ fi
- for db in $databases
- do
- DUMP_BASE="$MYSQLDUMP $defaultsfile --lock-tables --complete-insert --add-drop-table --quick --quote-names"
+ for db in $databases
+ do
+ DUMP_BASE="$MYSQLDUMP $defaultsfile $sqldumpoptions"
- # Dumping structure and data
- DUMP="$DUMP_BASE $ignore $db"
+ # Dumping structure and data
+ DUMP="$DUMP_BASE $ignore $db"
- # If requested, dump only the table structure for this database
- if echo "$nodata" | grep -E '(^|[[:space:]])'"$db\." >/dev/null
- then
- # Get the structure of the tables, without data
- DUMP_STRUCT="$DUMP_BASE --no-data $db"
- for qualified_table in $nodata
- do
- table=$( expr match "$qualified_table" "$db\.\([^\w]*\)" )
- DUMP_STRUCT="$DUMP_STRUCT $table"
- done
- DUMP="( $DUMP; $DUMP_STRUCT )"
- fi
- if [ $usevserver = yes ]
- then
- # Test to make sure mysqld is running, if it is not sqldump will not work
- $VSERVER $vsname exec su $user -c "$MYSQLADMIN $defaultsfile ping"
- if [ $? -ne 0 ]; then
- fatal "Either you have an authentication problem, or mysqld doesn't appear to be running!"
- fi
- if [ "$compress" == "yes" ]; then
- execstr="$VSERVER $vsname exec $DUMP | $GZIP > $vroot$dumpdir/${db}.sql.gz"
- else
- execstr="$VSERVER $vsname exec $DUMP -r $vroot$dumpdir/${db}.sql"
- fi
- else
- # Test to make sure mysqld is running, if it is not sqldump will not work
- su $user -c "$MYSQLADMIN $defaultsfile ping"
- if [ $? -ne 0 ]; then
- fatal "Either you have an authentication problem, or mysqld doesn't appear to be running!"
- fi
- if [ "$compress" == "yes" ]; then
- execstr="$DUMP | $GZIP > $dumpdir/${db}.sql.gz"
- else
- execstr="$DUMP -r $dumpdir/${db}.sql"
- fi
- fi
- debug "su $user -c \"$execstr\""
- if [ ! $test ]
- then
- output=`su $user -c "$execstr" 2>&1`
- code=$?
- if [ "$code" == "0" ]
- then
- debug $output
- info "Successfully finished dump of mysql database $db"
- else
- warning $output
- warning "Failed to dump mysql databases $db"
- fi
- fi
- done
+ # If requested, dump only the table structure for this database
+ if echo "$nodata" | grep -E '(^|[[:space:]])'"$db\." >/dev/null
+ then
+ # Get the structure of the tables, without data
+ DUMP_STRUCT="$DUMP_BASE --no-data $db"
+ for qualified_table in $nodata
+ do
+ table=$( expr match "$qualified_table" "$db\.\([^\w]*\)" )
+ DUMP_STRUCT="$DUMP_STRUCT $table"
+ done
+ DUMP="( $DUMP; $DUMP_STRUCT )"
+ fi
+ if [ $usevserver = yes ]
+ then
+ # Test to make sure mysqld is running, if it is not sqldump will not work
+ $VSERVER $vsname exec su $user -c "$MYSQLADMIN $defaultsfile ping 2>&1 >/dev/null"
+ if [ $? -ne 0 ]; then
+ fatal "mysqld doesn't appear to be running!"
+ fi
+ if [ "$compress" == "yes" ]; then
+ execstr="$VSERVER $vsname exec $DUMP | $GZIP --rsyncable > '$vroot$dumpdir/${db}.sql.gz'"
+ else
+ execstr="$VSERVER $vsname exec $DUMP -r '$vroot$dumpdir/${db}.sql'"
+ fi
+ else
+ # Test to make sure mysqld is running, if it is not sqldump will not work
+ su $user -c "$MYSQLADMIN $defaultsfile ping 2>&1 >/dev/null"
+ if [ $? -ne 0 ]; then
+ fatal "mysqld doesn't appear to be running!"
+ fi
+ if [ "$compress" == "yes" ]; then
+ execstr="$DUMP | $GZIP --rsyncable > '$dumpdir/${db}.sql.gz'"
+ else
+ execstr="$DUMP -r '$dumpdir/${db}.sql'"
+ fi
+ fi
+ debug "su $user -c \"$execstr\""
+ if [ ! $test ]
+ then
+ output=`su $user -c "set -o pipefail ; $execstr" 2>&1`
+ code=$?
+ if [ "$code" == "0" ]
+ then
+ debug $output
+ info "Successfully finished dump of mysql database $db"
+ else
+ warning $output
+ warning "Failed to dump mysql databases $db"
+ fi
+ fi
+ done
fi
# clean up tmp config file
if [ "$dbusername" != "" -a "$dbpassword" != "" ]
then
- ## clean up tmp config file
- debug "rm $workcnf"
- rm $workcnf
- if [ -f "$tmpcnf" ]
- then
- debug "mv $tmpcnf $workcnf"
- mv $tmpcnf $workcnf
- fi
+ ## clean up tmp config file
+ debug "rm $workcnf"
+ rm $workcnf
+ if [ -f "$tmpcnf" ]
+ then
+ debug "mv $tmpcnf $workcnf"
+ mv $tmpcnf $workcnf
+ fi
fi
return 0